searchNodes=[{"doc":"Estructura is a set of extensions for Elixir structures, such as Access implementation, Enumerable and Collectable implementations, validations and test data generation via StreamData . Estructura simplifies the following Access implementation for structs Enumerable implementation for structs (as maps) Collectable implementation for one of struct’s fields (as MapSet does) StreamData generation of structs for property-based testing Use Options use Estructura accepts four keyword arguments. access: boolean() whether to generate the Access implementation, default true ; when true , it also produces put/3 and get/3 methods to be used with coercion and validation coercion: boolean() | [key()] whether to generate the bunch of coerce_×××/1 functions to be overwritten by implementations, default false validation: boolean() | [key()] whether to generate the bunch of validate_×××/1 functions to be overwritten by implementations, default false enumerable: boolean() whether to generate the Enumerable porotocol implementation, default false collectable: false | key() whether to generate the Collectable protocol implementation, default false ; if non-falsey atom is given, it must point to a struct field where Collectable would collect. Should be one of list() , map() , MapSet.t() , bitstribg() generator: %{optional(key()) =&gt; Estructura.Config.generator()} the instructions for the __generate__/{0,1} functions that would produce the target structure values suitable for usage in StreamData property testing; the generated __generator__/1 function is overwritable. Please note, that setting coercion and/or validation to truthy values has effect if and only if access has been also set to true . Typical example of usage would be: defmodule MyStruct do use Estructura , access : true , coercion : [ :foo ] , validation : true , enumerable : true , collectable : :bar , generator : [ foo : { StreamData , :integer } , bar : { StreamData , :list_of , [ { StreamData , :string , [ :alphanumeric ] } ] } , baz : { StreamData , :fixed_map , [ [ key1 : { StreamData , :integer } , key2 : { StreamData , :integer } ] ] } ] defstruct foo : 42 , bar : [ ] , baz : %{ } end The above would allow the following to be done with the structure: s = % MyStruct { } put_in s , [ :foo ] , :forty_two #⇒ %MyStruct{foo: :forty_two, bar: [], baz: %{}} for i &lt;- [ 1 , 2 , 3 ] , into : s , do : i #⇒ %MyStruct{foo: 42, bar: [1, 2, 3], baz: %{}} Enum . map ( s , &amp; elem ( &amp;1 , 1 ) ) #⇒ [42, [], %{}] MyStruct . __generator__ ( ) |&gt; Enum . take ( 3 ) #⇒ [ # %MyStruct{bar: [], baz: %{key1: 0, key2: 0}, foo: -1}, # %MyStruct{bar: [&quot;g&quot;, &quot;xO&quot;], baz: %{key1: -1, key2: -2}, foo: 2}, # %MyStruct{bar: [&quot;&quot;, &quot;&quot;, &quot;&quot;], baz: %{key1: -3, key2: 1}, foo: -1} # ] Coercion When coercion: true | [key()] is passed as an argument to use Estructura , the nested behaviour Coercible is generated and the target module claims to implement it. To make a coercion work with MyStruct.put/3 and put_in/3 provided by Access implementation, the consumer module should implement MyStruct.Coercible behaviour. For the consumer convenience, the warnings for not implemented functions will be issued by compiler. Validation When validation: true | [key()] is passed as an argument to use Estructura , the nested behaviour Validatable is generated and the target module claims to implement it. To make a validation work with MyStruct.put/3 and put_in/3 provided by Access implementation, the consumer module should implement MyStruct.Validatable behaviour. For the consumer convenience, the warnings for not implemented functions will be issued by compiler. Generation If generator keyword argument has been passed, MyStruct.__generate__/{0,1} can be used to generate instances of this struct for StreamData property based tests. property &quot;generation&quot; do check all % MyStruct { foo : foo , bar : bar , baz : baz } &lt;- MyStruct . __generator__ ( ) do assert match? ( %{ key1 : v1 , key2 : v2 } when is_integer ( v1 ) and is_integer ( v2 ) , baz ) assert is_integer ( foo ) assert is_binary ( bar ) end end","ref":"Estructura.html","title":"Estructura","type":"module"},{"doc":"The configuration of the Estructura that is built from the parameters, passed as a second argument in a call to use Estructura . One normally does not need to meddle with this module.","ref":"Estructura.Config.html","title":"Estructura.Config","type":"module"},{"doc":"The generator to be passed to use Estructura should be given in one of these forms","ref":"Estructura.Config.html#t:generator/0","title":"Estructura.Config.generator/0","type":"type"},{"doc":"The structure key","ref":"Estructura.Config.html#t:key/0","title":"Estructura.Config.key/0","type":"type"},{"doc":"The configuration of Estructura","ref":"Estructura.Config.html#t:t/0","title":"Estructura.Config.t/0","type":"type"},{"doc":"The structure value","ref":"Estructura.Config.html#t:value/0","title":"Estructura.Config.value/0","type":"type"},{"doc":"Full Example","ref":"Estructura.Full.html","title":"Estructura.Full","type":"module"},{"doc":"Returns the generator to be used in StreamData -powered property testing, based on the specification given to use Estructura.Full .","ref":"Estructura.Full.html#__generator__/0","title":"Estructura.Full.__generator__/0","type":"function"},{"doc":"Returns the generator to be used in StreamData -powered property testing, based on the specification given to use Estructura.Full , which was % Estructura.Config { access : true , coercion : [ :foo ] , collectable : :bar , enumerable : true , generator : [ foo : { StreamData , :integer , [ 0 .. 1000 ] } , bar : { StreamData , :string , [ :alphanumeric ] } , baz : { StreamData , :fixed_map , [ [ key1 : { StreamData , :integer } , key2 : { StreamData , :integer } ] ] } , zzz : &amp; Estructura.Full . zzz_generator / 0 ] , validation : true } The argument given would be used as a template to generate new values.","ref":"Estructura.Full.html#__generator__/1","title":"Estructura.Full.__generator__/1","type":"function"},{"doc":"Gets the value for the given key from the structure","ref":"Estructura.Full.html#get/3","title":"Estructura.Full.get/3","type":"function"},{"doc":"Puts the value for the given key into the structure, passing coercion and validation","ref":"Estructura.Full.html#put/3","title":"Estructura.Full.put/3","type":"function"},{"doc":"Extensions for Elixir structures.","ref":"readme.html","title":"Estructura","type":"extras"},{"doc":"def deps do [ { :estructura , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"Estructura - Installation","type":"extras"},{"doc":"0.3.0 —  coercion and validation are now injected as behaviours 0.2.0 —  coercion , validation , put/3","ref":"readme.html#changelog","title":"Estructura - Changelog","type":"extras"},{"doc":"","ref":"readme.html#documentation","title":"Estructura - Documentation","type":"extras"}]